// ********************************************************************************** //
// The contents of this file are subject to the Mozilla Public License Version 1.1    //
// (the "License"); you may not use this file except in compliance with the License.  //
// You may obtain a copy of the License at http://www.mozilla.org/MPL/                //
//                                                                                    //
// Software distributed under the License is distributed on an "AS IS" basis,         //
// WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License for the  //
// specific language governing rights and limitations under the License.              //
//                                                                                    //
// The Original Code provided by Mozilla's Firefox is XUL, Javascript, and CSS.       // 
// The Initial Developer of the Original Code is Aseem Kishore.                       //
// Portions created by Scott Williamson are Copyright (c) 2006.  All Rights Reserved. //
// Contributor - Intuit Inc. (c) 2007                                                 //
// ********************************************************************************** //

// -- DRAWING -- //


function thumbstrips_openTray() 
{
	if (thumbstrips_tray.getAttribute("hidden")) 
	{	// if tray is closed
//		thumbstrips_drawFilmstrip(); // optional, but opening/closing is a good way to "fix" bugs
		
		thumbstrips_tray.removeAttribute("hidden");
		thumbstrips_splitter.removeAttribute("hidden");
		
		var item = document.getElementById("thumbstrips_viewFilmstripMenuItem");
		item.setAttribute("checked", "true");
		
		var thumbstripsButton = document.getElementById("thumbstrips_openButtonOn");

        if(thumbstripsButton!=null)
        {
    		thumbstripsButton.setAttribute("checked", "true");
	    }
	    	
		if (thumbstrips_prefs.getBoolPref("options.mouse_scroll") === true) 
		{
			window.addEventListener("mousemove", thumbstrips_updateMousePosition, true);
			thumbstrips_mouseScrollUpdater = window.setInterval(thumbstrips_mouseScroll, thumbstrips_prefs.getIntPref("time.mouse_update_frequency"));
		}
		
		thumbstrips_splitter.addEventListener("mousedown", thumbstrips_beginResizingThumbnails, false);
		thumbstrips_splitter.addEventListener("mouseup", thumbstrips_endResizingThumbnails, false);
		
		// the above commented code has been moved to:
		thumbstrips_skipToCurrent();
		
	} 
	else 
	{	// if tray is open
		thumbstrips_tray.setAttribute("hidden", "true");
		thumbstrips_splitter.setAttribute("hidden", "true");
		
		var item = document.getElementById("thumbstrips_viewFilmstripMenuItem");
		item.setAttribute("checked", "false");
		
		var thumbstripsButton = document.getElementById("thumbstrips_openButtonOn");

        if(thumbstripsButton!=null)
        {
    		thumbstripsButton.setAttribute("checked", "false");
	    }	
		
		window.removeEventListener("mousemove", thumbstrips_updateMousePosition, true);
		window.clearInterval(thumbstrips_mouseScrollUpdater);
		
		thumbstrips_splitter.removeEventListener("mousedown", thumbstrips_beginResizingThumbnails, false);
		thumbstrips_splitter.removeEventListener("mouseup", thumbstrips_endResizingThumbnails, false);
	}
}

function thumbstrips_drawFilmstrip() 
{
    var renderer = new thumbstripsFilmstripRenderer();
    renderer.Draw();
    renderer = null;
}


function thumbstrips_getOriginalId(id, visitCount, debug) 
{	
	return visitCount ? id.slice(0, id.lastIndexOf(visitCount)) : id;
}



function thumbstrips_removeThumbnail(sourceUrl, visitIndex) 
{	
	var webPageNode = thumbstrips_GetFilmstrip().GetWebPageNodeByUrl(sourceUrl);

    if(visitIndex > -1)
    {
        thumbstrips_GetFilmstrip().RemoveWebsiteVisit(sourceUrl, visitIndex);
    }	
    else
    {
        thumbstrips_GetFilmstrip().RemoveWebsiteNode(sourceUrl);
    }
    
	if (thumbstripsGetCurrentWebPageNode().m_url === sourceUrl) 
	{
		thumbstrips_clearUpdaters();
		thumbstrips_deletedUrl = sourceUrl;
	}

    var renderer = new thumbstripsFilmstripRenderer();
    renderer.Draw(true);
    renderer = null;
}


function thumbstrips_showProperties(id, visitCount) 
{
	var origId = thumbstrips_getOriginalId(id, visitCount, true);
	var node = thumbstrips_GetFilmstrip().GetWebPageNodeByUrl(origId);
	
	window.openDialog("chrome://thumbstrips/content/propsdialog.xul", "", "chrome,modal,centerscreen", node);
}

function thumbstrips_updateTimes() 
{
    var renderer = new thumbstripsFilmstripRenderer();
    renderer.UpdateTimes();
    renderer = null;
}

function thumbstrips_beginResizingThumbnails() {
//	thumbstrips_resizeUpdater = window.setInterval(thumbstrips_resizeThumbnails, 20);
	window.addEventListener("mousemove", thumbstrips_resizeThumbnails, true);
}

function thumbstrips_resizeThumbnails() {
//	thumbstrips_log("resizing...");
	    
	var renderer = new thumbstripsFilmstripRenderer();
	renderer.Resize();
	renderer = null;
//	var nodes = thumbstrips_box.childNodes;
//	
//	if (nodes.length === 0) 
//	{
//		return;
//	}
//	
//	var hBox;
//	
//	if (thumbstrips_hidden.getAttribute("hidden")) 
//	{	// i.e. there is a scrollbar
//		hBox = thumbstrips_box.boxObject.height - 16;
//	} 
//	else 
//	{	// i.e. there is no scrollbar
//		hBox = thumbstrips_box.boxObject.height;
//	}
//	
////	var hBox = thumbstrips_box.boxObject.height;
//	var hMin = thumbstrips_prefs.getIntPref("style.thumb_min_height");
//	var hMax = thumbstrips_prefs.getIntPref("style.thumb_max_height");
//	var hText = thumbstrips_textHeight;
//	var hNew = ((hBox - hText) < hMin) ? hMin : (((hBox - hText) > hMax) ? hMax : (hBox - hText));
//	
//	var tempThumb = document.getElementById(thumbstrips_thumbnailClass + nodes[0].id);
//		
//	// in some cases, node.id will be [url][vc] while canvas.id will be [canvas-class][url]
//	if (!tempThumb && nodes[0].getAttribute("vc")) 
//	{
//		var tempId = thumbstrips_getOriginalId(nodes[0].id, nodes[0].getAttribute("vc"));
//		tempThumb = document.getElementById(thumbstrips_thumbnailClass + tempId);
//	}
//	
//	var scale = hNew / tempThumb.displayHeight;
//	
//	for (var i = 0; i < nodes.length; i++) 
//	{
////		var thumb = thumbstrips_filmstrip.getNodeById(nodes[i].id).thumbnail;
//		var thumb = document.getElementById(thumbstrips_thumbnailClass + nodes[i].id);
//		
//		if (!thumb && nodes[i].getAttribute("vc")) {
//			var tempId = thumbstrips_getOriginalId(nodes[i].id, nodes[i].getAttribute("vc"));
//			thumb = document.getElementById(thumbstrips_thumbnailClass + tempId);
//		}
//		
//		thumb.displayHeight = hNew;
//		thumb.displayWidth *= scale;
//		
//		thumb.style.height = thumb.displayHeight + "px";
//		thumb.style.minHeight = thumb.style.height;
//		thumb.style.maxHeight = thumb.style.height;
//		
//		thumb.style.width = thumb.displayWidth + "px";
//		thumb.style.minWidth = thumb.style.width;
//		thumb.style.maxWidth = thumb.style.width;
//	}
//	
//	thumbstrips_currentHeight = hNew;
}

function thumbstrips_endResizingThumbnails() {
//	window.clearInterval(thumbstrips_resizeUpdater);
	window.removeEventListener("mousemove", thumbstrips_resizeThumbnails, true);
	thumbstrips_resizeThumbnails();
}

function thumbstrips_addScrollbar() 
{
	var inner = document.getAnonymousNodes(thumbstrips_box).item(0);
	
	if (thumbstrips_box.boxObject.width >= inner.boxObject.width) {
		return;
	}
	
	var h = thumbstrips_box.boxObject.height;
	
//	thumbstrips_box.setAttribute("style", "height: " + (h + 16) + "px; overflow: auto;");
	thumbstrips_box.style.height = (h + 16) + "px";
	thumbstrips_box.style.overflow = "auto";
	SetScrollBarShowing(true);
//	thumbstrips_box.setAttribute("onmousedown", "thumbstrips_considerStopMouseScroll(event);");
//	thumbstrips_box.setAttribute("onmouseup", "thumbstrips_considerStartMouseScroll(event);");
	
//	thumbstrips_log("added scrollbar");
}

function thumbstrips_removeScrollbar() 
{
	var inner = document.getAnonymousNodes(thumbstrips_box).item(0);
	
	if (thumbstrips_box.boxObject.width <= inner.boxObject.width) 
	{
		return;
	}
	
	var h = thumbstrips_box.boxObject.height;
	
//	thumbstrips_box.setAttribute("style", "height: " + (h - 16) + "px;");
	thumbstrips_box.style.height = (h - 16) + "px";
	thumbstrips_box.style.removeProperty("overflow");
	SetScrollBarShowing(false);

//	thumbstrips_box.removeAttribute("onmousedown");
//	thumbstrips_box.removeAttribute("onmouseup");
	
//	thumbstrips_log("removed scrollbar");
}

function thumbstrips_changeScrollbar() {
	var inner = document.getAnonymousNodes(thumbstrips_box).item(0);
	
	if (thumbstrips_box.boxObject.width < inner.boxObject.width) { // overflow
//		thumbstrips_log("overflow happened");
	} else {
//		thumbstrips_log("underflow happened");
	}
}


function thumbstrips_considerStopMouseScroll(event) {
	if (thumbstrips_prefs.getBoolPref("options.mouse_scroll") === true) {
		var mY = event.screenY;
		var sY = thumbstrips_box.screenY + thumbstrips_box.boxObject.height - 16;
		
		if (mY >= sY) { // we clicked on the scrollbar or lower
			thumbstrips_log("we clicked on the scrollbar or lower");
			window.removeEventListener("mousemove", thumbstrips_updateMousePosition, true);
			window.clearInterval(thumbstrips_mouseScrollUpdater);
			thumbstrips_mousePause = true;	
		}
	}
}

function thumbstrips_considerStartMouseScroll(event) {
	if (thumbstrips_prefs.getBoolPref("options.mouse_scroll") === true && thumbstrips_mousePause === true) {
		window.addEventListener("mousemove", thumbstrips_updateMousePosition, true);
		thumbstrips_mouseScrollUpdater = window.setInterval(thumbstrips_mouseScroll, thumbstrips_prefs.getIntPref("time.mouse_update_frequency"));
		thumbstrips_mousePause = false;
	}
}



function thumbstrips_updateMousePosition(event) 
{
	thumbstrips_mouseX = event.screenX;
	thumbstrips_mouseY = event.screenY;
}

function thumbstrips_toggleSortingPreferences(menu) 
{
    var sortManager = new thumbstripsSortManager();
    sortManager.ProcessMenuChange();
    sortManager = null;
}


function thumbstrips_setSorting() 
{
    var renderer = new thumbstripsFilmstripRenderer();
    renderer.ClearContents();
    renderer.Draw(true);
    renderer = null;
}