// ********************************************************************************** //
// The contents of this file are subject to the Mozilla Public License Version 1.1    //
// (the "License"); you may not use this file except in compliance with the License.  //
// You may obtain a copy of the License at http://www.mozilla.org/MPL/                //
//                                                                                    //
// Software distributed under the License is distributed on an "AS IS" basis,         //
// WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License for the  //
// specific language governing rights and limitations under the License.              //
//                                                                                    //
// The Original Code provided by Mozilla's Firefox is XUL, Javascript, and CSS.       // 
// The Initial Developer of the Original Code is Aseem Kishore.                       //
// Portions created by Scott Williamson are Copyright (c) 2006.  All Rights Reserved. //
// Contributor - Intuit Inc. (c) 2007                                                 //
// ********************************************************************************** //

// -- OPTIONS DIALOG -- //


var thumbstrips_optionsDialog;

var thumbstrips_prefs = window.arguments[0];
var optionsDialogDoNotRecordList = window.arguments[1];

function thumbstrips_onOptionsDialogLoad() 
{
	var pageUpdateFrequency = thumbstrips_prefs.getIntPref("time.page_update_frequency");
	
    if(pageUpdateFrequency > 600)
    {
        // if the page update frequency is > than the largest new value allowed
        // then convert it down to the new allowed values as closely as possible.
        if(pageUpdateFrequency > 999)
        {
            pageUpdateFrequency = pageUpdateFrequency / 1000;
        }
        else
        {
            pageUpdateFrequency = 1;
        }
    
        thumbstrips_prefs.setIntPref("time.page_update_frequency", pageUpdateFrequency);
    }
   
	thumbstrips_propsDialog = document.getElementById("thumbstrips_optionsDialog");
	
	// set reset button
	
	reset = thumbstrips_propsDialog.getButton("extra1");
	reset.setAttribute("oncommand", "thumbstrips_onOptionsReset();");
	
//	
	thumbstrips_onOptionsReset();
}


function thumbstrips_onOptionsDialogAccept() 
{
    var pageFrequencySelection = document.getElementById("thumbstripsUpdateFrequencySelection");
	thumbstrips_prefs.setIntPref("time.page_update_frequency", pageFrequencySelection.value);
    
    var openTrayOnStartup = document.getElementById("thumbstripsOpenTrayOnStartup");
    var startRecordingOnStartup = document.getElementById("thumbstripsStartRecordingOnStartup");
    
    thumbstrips_prefs.setBoolPref("startup.openTray", openTrayOnStartup.checked);
    thumbstrips_prefs.setBoolPref("startup.startRecording", startRecordingOnStartup.checked);

    var neverRecordSecureSites = document.getElementById("thumbstripsNeverRecordSecureSites");
    thumbstrips_prefs.setBoolPref("recording.doNotRecordSecureSites", neverRecordSecureSites.checked);

    optionsDialogDoNotRecordList.UpdateSSLPreference(thumbstrips_prefs.getBoolPref("recording.doNotRecordSecureSites"));
}

function thumbstrips_onOptionsReset() 
{
	var pageFrequencySelection = document.getElementById("thumbstripsUpdateFrequencySelection");
	var pageUpdateFrequency = thumbstrips_prefs.getIntPref("time.page_update_frequency");
	pageFrequencySelection.value = pageUpdateFrequency;
	
	var openTrayOnStartup = document.getElementById("thumbstripsOpenTrayOnStartup");
    var startRecordingOnStartup = document.getElementById("thumbstripsStartRecordingOnStartup");
    
    openTrayOnStartup.checked = thumbstrips_prefs.getBoolPref("startup.openTray");
    startRecordingOnStartup.checked = thumbstrips_prefs.getBoolPref("startup.startRecording");

    var neverRecordSecureSites = document.getElementById("thumbstripsNeverRecordSecureSites");
    neverRecordSecureSites.checked =  thumbstrips_prefs.getBoolPref("recording.doNotRecordSecureSites");
}

function thumbstrips_onOptionsDialogCancel() 
{
	// nothing
}
