var thumbstripsThumbnailContainerObserver = {
  
  onDragStart: function (evt , transferData, action)
  {
    transferData.data=new TransferData();
    transferData.data.addDataForFlavour("text/unicode", evt.target.getAttribute("SourceUrl"));
  }
};

var thumbstripsThumbnailBoxObserver = {
  
  getSupportedFlavours : function () 
  {
    var flavours = new FlavourSet();
    flavours.appendFlavour("text/unicode");
    return flavours;
  },
  
  onDragOver: function (evt,flavour,session)
  {
     var mouseX = evt.pageX;
     var mouseY = evt.pageY;
     
    var boxR = thumbstrips_box.boxObject.width / 2;
	var boxX = thumbstrips_box.boxObject.screenX + boxR;
	
	if (mouseY < thumbstrips_box.boxObject.screenY) 
	{
		return;
	}
	
	// is the scrollbar visible? if so, don't scroll if mouse is on it
	// (note that when visible, thumbstrips_box is full width including scrollbar,
	// so we need to subtract 16px. when hidden, thumbstrips_box is 16px shorter,
	// so we need to add 16px for the "hidden" component.)
	
	if (IsScrollBarShowing()) 
	{	// scrollbar visible
		if (mouseY > thumbstrips_box.boxObject.screenY + thumbstrips_box.boxObject.height - 16) 
		{
			return;
		}
	} 
	else 
	{	// scrollbar hidden
		if (mouseY > thumbstrips_box.boxObject.screenY + thumbstrips_box.boxObject.height + 16) 
		{
			return;
		}
	}
	
	var rPlateau = thumbstrips_prefs.getIntPref("scrolling.plateau_radius");
	var maxSpeed = thumbstrips_prefs.getIntPref("scrolling.max_speed");
	
	var xLeftOuter = boxX - boxR;
	var xLeftInner = boxX - rPlateau;
	var xRightInner = boxX + rPlateau;
	var xRightOuter = boxX + boxR;
	
	if ((mouseX > xLeftInner) && (mouseX < xRightInner)) 
	{
		// in plateau zone, no scrolling
		return;
	} 
	else if ((mouseX < xLeftOuter - 1) || (mouseX > xRightOuter + 1)) 
	{
		// outside filmstrip box, no scrolling
		return;
	}
	
  	var n = Math.log(maxSpeed + 1);
	var m = n / (xRightOuter - boxX);
	
	var scrollSpeed = Math.exp(m * Math.abs(mouseX - boxX));
	
	scrollSpeed *= (mouseX < boxX) ? -1 : 1;
	
	thumbstrips_scrollbox.scrollBy(new Number(scrollSpeed), new Number(0));
  },
  
  onDrop: function (evt,transferData,session)
  {
    if (transferData.data!="")
    {
      var renderer = new thumbstripsFilmstripRenderer();
      renderer.RelocateThumbnailContainer(transferData.data, evt.pageX); 
      renderer = null;
    }
   }
};


