// ********************************************************************************** //
// The contents of this file are subject to the Mozilla Public License Version 1.1    //
// (the "License"); you may not use this file except in compliance with the License.  //
// You may obtain a copy of the License at http://www.mozilla.org/MPL/                //
//                                                                                    //
// Software distributed under the License is distributed on an "AS IS" basis,         //
// WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License for the  //
// specific language governing rights and limitations under the License.              //
//                                                                                    //
// The Original Code provided by Mozilla's Firefox is XUL, Javascript, and CSS.       // 
// Contributor - Intuit Inc. (c) 2007                                                 //
// ********************************************************************************** //

// webpagenode.js

var thumbstrips_WN_CHECK_REP = true;

function thumbstripsWebPageNode(url, pageThumbnail, scrollX, scrollY, visitList, visitTimeInMilliseconds) 
{
    this.m_url = url;
	this.m_visitInformation = new thumbstripsWebPageVisitNode(url, visitList);
}

thumbstripsWebPageNode.prototype.GetThumbnail = thumbstripsWebPageNodeGetThumbnail
thumbstripsWebPageNode.prototype.Destroy = thumbstripsWebPageNodeDestroy;
thumbstripsWebPageNode.prototype.BeginNewVisit = thumbstripsWebPageNodeBeginNewVisit;
thumbstripsWebPageNode.prototype.UpdateCurrentVisit = thumbstripsWebPageNodeUpdateCurrentVisit;
thumbstripsWebPageNode.prototype.UpdateContents = thumbstripsWebPageNodeUpdateContents;

function thumbstripsWebPageNodeDestroy()
{   
    if(this.m_visitInformation!=null)
    {
        this.m_visitInformation.Destroy();
        this.m_visitInformation = null;
    }
}

function thumbstripsWebPageNodeGetThumbnail()
{
    return thumbstrips_GetFilmstrip().m_thumbnailArray.FindByUrl(this.m_url);
}

function thumbstripsWebPageNodeBeginNewVisit()
{	
    if(this.m_visitInformation==null)
        this.m_visitInformation = new thumbstripsWebPageVisitNode("",null);
        
    this.m_visitInformation.BeginNewVisit();
}

function thumbstripsWebPageNodeUpdateCurrentVisit(dontAddTime)
{	
    if(this.m_visitInformation==null)
        this.m_visitInformation = new thumbstripsWebPageVisitNode("",null);
        
    this.GetThumbnail().m_visitTimeInMilliseconds = this.m_visitInformation.UpdateCurrentVisit(dontAddTime, this.GetThumbnail().m_visitTimeInMilliseconds);
}

function thumbstripsWebPageNodeUpdateContents(content)
{
    this.m_visitInformation.UpdateCurrentVisit(false);
    thumbstrips_GetFilmstrip().m_thumbnailArray.UpdateThumbnailFromContent(content);
}    
	
var thumbstripsWebPageNodeCurrentNode = null;

function thumbstripsGetCurrentWebPageNode()
{
    return thumbstripsWebPageNodeCurrentNode;
}

function thumbstripsSetCurrentWebPageNode(webPageNode)
{
    if(thumbstripsWebPageNodeCurrentNode!=null)
    {
        if(webPageNode==null || thumbstripsWebPageNodeCurrentNode.m_visitInformation.m_url!=webPageNode.m_visitInformation.m_url)
        {
            thumbstripsWebPageNodeCurrentNode.Destroy();
            thumbstripsWebPageNodeCurrentNode = null;
            thumbstripsWebPageNodeCurrentNode = webPageNode;
        }
    }
    else
    {
        thumbstripsWebPageNodeCurrentNode = webPageNode;
    }
}




